<template>
  <v-app id="fanfest">
    <v-app-bar
      color="white"
      style="width: 100%"
    >
      <v-toolbar
        color="primary"
        :elevation="8"
      >
        <!-- tabs -->

        <v-tabs
          v-model="tab"
          align-tabs="start"
        >
          <v-tab
            v-for="(item, i) in tabs"
            :key="i"
            :to="item"
          >
            {{ item.title }}
          </v-tab>
          <v-tab
            v-if="userStore.isAdministrator"
            :to="{name:'trivia-administration'}"
          >
            Administration
          </v-tab>
        </v-tabs>
        <div class="fanfest-icon pt-2 rounded-pill">
          <fanfest-icon />
        </div>
        <v-spacer />

        <!-- buttons -->

        <v-toolbar-items>
          <!-- logged in -->
          <v-tooltip
            v-if="
              userStore.user"
            text="Change Your Nickname"
            location="bottom"
          >
            <template #activator="{ props }">
              <v-btn
                v-bind="props"
                class="mr-n5"
                icon
                @click="renameUser()"
              >
                <v-icon>mdi-rename</v-icon>
              </v-btn>
            </template>
          </v-tooltip>

          <v-tooltip
            v-if="userStore.user"
            text="Log Out"
            location="bottom"
          >
            <template #activator="{ props }">
              <v-btn
                v-bind="props"
                append-icon="mdi-logout"
                @click="signOutUser()"
              >
                Hello {{ userStore.user.nickname }}
              </v-btn>
            </template>
          </v-tooltip>

          <!-- not logged in -->

          <v-tooltip
            v-if="!userStore.user"
            text="Log In"
            location="bottom"
          >
            <template #activator="{ props }">
              <v-btn
                v-bind="props"
                append-icon="mdi-login"
                @click="showAuthenticator = true"
              >
                Log In
              </v-btn>
            </template>
          </v-tooltip>
        </v-toolbar-items>
      </v-toolbar>
    </v-app-bar>

    <!-- content -->

    <v-main>
      <router-view />
      <authenticate-user
        :show="showAuthenticator"
        @on-signed-in="onSignedIn"
        @on-signed-out="onSignedOut"
      />
    </v-main>
  </v-app>
</template>

<script setup>
import { ref } from "vue"
import { put } from "aws-amplify/api"
import { RouterView } from "vue-router"
import { signOut, updateUserAttribute } from "aws-amplify/auth"
//
import AWSServerlessWebSocket from "@/js/AWSServerlessWebSocket.js"
import { useUserStore } from "@/stores/userStore.js"
const userStore = useUserStore()
import { useMatchStore } from "@/stores/matchStore.js"
const matchStore = useMatchStore()
//
import AuthenticateUser from "@/components/AuthenticateUser.vue"
import FanfestIcon from "@/components/icons/FanfestIcon.vue"

let tab = ref(0)
let showAuthenticator = ref(false)
let socket

const tabs = [
  {
    title: "Trivia",
    name: "trivia-game"
  },
  {
    title: "Leaderboard",
    name: "trivia-leaderboard"
  },
  {
    title: "Help",
    name: "trivia-help"
  }
]

const onSignedIn = async (user) => {
  userStore.signedIn(user)
  hideAuthenticator()
  
  openWebSocket(user)
}

const onSignedOut = () => {
  userStore.signedOut()
  hideAuthenticator()
  
  closeWebSocket()
}

const hideAuthenticator = () => {
  showAuthenticator.value = false
}

const signOutUser = () => {
  hideAuthenticator()
  signOut()
}

const renameUser = async () => {
  if (userStore.user) {
    const newNickname = prompt("Enter your new Nickname", userStore.user.nickname)

    if (newNickname && newNickname !== userStore.user.nickname) {
      const result = await updateUserAttribute({
        userAttribute: {
          attributeKey: "nickname",
          value: newNickname
        }
      })

      if (result.isUpdated) {
        userStore.user.nickname = newNickname
      }

      try {
        const restOperation = put({
          apiName: "fanfesttrivia",
          path: "/trivia/player/nickname",
          options: {
            body: {
              nickname: newNickname
            }
          }
        })

        const { body } = await restOperation.response
        const response = await body.json()
        console.log("PUT call succeeded")
        console.log(response)
      } catch (error) {
        console.error(error)
      }
    }
  }
}

const openWebSocket = async (user) => {
  socket = new AWSServerlessWebSocket(
    "wss://dta787tcm8.execute-api.eu-west-1.amazonaws.com/production/",
    {
      application: "trivia",
      client: user.sub
    }
  )

  await socket.subscribe((message) => {
    console.log("message received", message)
    switch(message.action) {
      case "startMatch":
        matchStore.startMatch(message.match, userStore.user.sub)
        break

      case "addResult":
        matchStore.addResult(message)
        break
    }
  })
}

const closeWebSocket = () => {
  if (socket) {
    socket.close()
    socket = undefined
  }
}

</script>

<style>
  @media screen and (orientation:landscape) {
    .fanfest-icon{
      background-color: white;
      position: absolute;
      left:50%;
      top:10px;
      transform: translate(-50%);
    }
  }

  @media screen and (orientation:portrait) {
    .fanfest-icon{
      display:none;
      visibility: false;
    }
  }
  </style>